/******************************************************************************/
/******************************************************************************/
/* Trigger: DTULTATU_TBMETOAVAL                                                                                               */
/* Tabela : TBMETOAVAL                                                           */
/*                                                                            */
/* Criao:                                                                   */
/* 09/11/2004 - Rafael dos Santos Lopes                                       */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_TBMETOAVAL
BEFORE INSERT OR UPDATE OR DELETE
ON TBMETOAVAL FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUTBMA := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.DSTBMETOAVAL,0) <> NVL(:NEW.DSTBMETOAVAL,0)) OR
           (NVL(:OLD.CDTBREFMETOA,0) <> NVL(:NEW.CDTBREFMETOA,0)) OR
           (NVL(:OLD.VRIDADEFINTB,0) <> NVL(:NEW.VRIDADEFINTB,0)) OR
           (NVL(:OLD.VRIDADEINITB,0) <> NVL(:NEW.VRIDADEINITB,0)) THEN
         :NEW.DTULTATUTBMA := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('TBMETOAVAL', '', 'CDTBMETOAVAL='||:OLD.CDTBMETOAVAL||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE TBMETOAVAL MODIFY DTULTATUTBMA DEFAULT SYSDATE
/

