/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TCTR                                                     */
/* Tabela : TIPOCTRECEBER                                                     */
/*                                                                            */
/* Criao:                                                                   */
/* 28/02/2007 - ARNALDO COUTINHO BRITO JNIOR                                 */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_TCTR'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_TCTR
GO

CREATE TRIGGER DTULTATU_TCTR
ON TIPOCTRECEBER
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'TIPOCTRECEBER', null, 'CDTPCTRECEB=' + CDTPCTRECEB + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE TIPOCTRECEBER
      SET DTULTATUTCTR = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(TIPOCTRECEBER.CDTPCTRECEB,0  ) = ISNULL(INSERTED.CDTPCTRECEB,0  )) AND
            (ISNULL(TIPOCTRECEBER.CDCLASSFINA,0  ) = ISNULL(INSERTED.CDCLASSFINA,0  )) AND
            (ISNULL(TIPOCTRECEBER.CDCONTCTBL,0   ) = ISNULL(INSERTED.CDCONTCTBL,0   )) AND
            (ISNULL(TIPOCTRECEBER.IDCTBLCTREC,0  ) = ISNULL(INSERTED.IDCTBLCTREC,0  )) AND
            (ISNULL(TIPOCTRECEBER.IDTPCTRECEBER,0) = ISNULL(INSERTED.IDTPCTRECEBER,0));
   END;
END;
GO



-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_TCTR','4.11.072';
GO

