var Cus01500_CurvaABCServicoPlanejadoController = function(ScreenService, restEngine, maskEngine, ZhUtil, General, GeneralServices) {
	var dataSetTree;
	var parent;
	var relatorio;
	var codigo;
	var unidade;
	var filterReport;
	var self = this;


	this.defaultValues = function(widget) {
		if (!widget.currentRow.CDFILIAL) {
			widget.newRow();
		}
		if(!widget.backupRow){
			var relatorio = widget.getField('REPORT_NAME').dataSource.getFirstRow();
			widget.currentRow.CD_REPORT_NAME = relatorio.value;
			General.setLoggedUnit(widget.container.getWidget('cus01500'));
			widget.currentRow.NMFILIAL = getLocalVar('CDFILIAL') + ' | ' + getLocalVar('NMFILIAL');
			var date = getLocalVar('DTPROCESSA') ? moment(getLocalVar('DTPROCESSA'), 'DD/MM/YYYY').format('DD/MM/YYYY') : moment().format('DD/MM/YYYY');
			widget.currentRow.PERIODO = {
				'start': date,
				'end': date,
				'formattedStart': date,
				'formattedEnd': date
			};
			GeneralServices.retornaTipoCustoPadrao(getLocalVar('CDFILIAL')).then(function(callback) {
				if(callback.dataset.defaulttipocusto[0]) {	
					widget.getField('NMTIPOCUSTO').setValue(callback.dataset.defaulttipocusto[0].CDTIPOCUSTO + ' | ' + callback.dataset.defaulttipocusto[0].NMTIPOCUSTO);
					widget.currentRow.CDTIPOCUSTO = callback.dataset.defaulttipocusto[0].CDTIPOCUSTO;
				}
			});
		} else {
			widget.currentRow = widget.backupRow;
		}
	};
	
	var beforeGenerateReport = function(callback){
		callback.metadata.filter = filterReport;
	};
	
	var prepareFilterReport = function(row, widget) {
		filterReport = [];
		var assoc = {
			'S': 'Sim',
			'Y': 'Sim',
			'N': 'Não'
		};
		var fields = ['NMFILIAL', 'PERIODO', 'NMTIPOCUSTO', 'NMPRODINICIO_NMPRODFINAL', 'IDMATEPRIM', 'IDNESTOCAVEIS', 'IDCONSPERC', 'IDCONSFIXO'];
		fields.forEach(function(key){
			var field = widget.getField(key);
			if(field){
				var item = {
					'label': field.label,
					'value': typeof row[key] === 'object' ? row[key].start + ' até ' + row[key].end : row[key]
				};
				item.value = item.value === 'S' || item.value === 'Y' || item.value === 'N' ? assoc[item.value] : item.value;
				filterReport.push(item);
			} else if(key.indexOf('_') > -1){
				var produtos = key.split('_');
				var aux = {
					'label': 'Produto',
					'value': row[produtos[0]] + ' a ' + row[produtos[1]] 
				};
				filterReport.push(aux);
			}
		});
	};
	
	this.setValueProd = function (field){
		var widget = field.widget;
		if(field.name === 'NMPRODINICIO'){
			widget.currentRow.PRODUTOINIC = widget.currentRow.CDPRODUTO;
			widget.currentRow.CDPRODINICIO = widget.currentRow.CDARVPROD;
			widget.currentRow.NMPRODFINAL = widget.currentRow.NMPRODINICIO;
			widget.currentRow.PRODUTOFINA = widget.currentRow.PRODUTOINIC;
			widget.currentRow.CDPRODFINAL = widget.currentRow.PRODUTOINIC;
		} else {
			widget.currentRow.PRODUTOFINA = widget.currentRow.CDPRODUTO;
			widget.currentRow.CDPRODFINAL = widget.currentRow.CDARVPROD;
		}
	};

	this.validaData = function(currentRow) {

		var dataInicial = currentRow.DTINICIAL ? moment(currentRow.DTINICIAL, 'DD/MM/YYYY')._d : null;
		var dataFinal = currentRow.DTFINAL ? moment(currentRow.DTFINAL, 'DD/MM/YYYY')._d : null;
		var mensagem = "A data final deve ser menor ou igual a data final.";

        if (dataInicial && dataFinal && dataFinal < dataInicial) {
            ScreenService.showMessage(mensagem);
            return false;
        }

		dataIni = currentRow.DTINICIAL;
		dataFim = currentRow.DTFINAL;

		var primeiroDia = moment(dataIni, 'DD/MM/YYYY').startOf('month').format('DD/MM/YYYY');
		var ultimoDia =  moment(dataFim, 'DD/MM/YYYY').endOf('month').format('DD/MM/YYYY');

		currentRow.DTMESINIC = primeiroDia;
		currentRow.DTMESFINA = ultimoDia;

		return true;
	};

	this.atualizaListaDeServico = function(widget) {
		var grupoServicos = '';
		var currentRow = widget.currentRow;

		if(currentRow.ALLGRUPSERV == 'N') {
			if (currentRow.NMGRUPSERV.length) {
				grupoServicos = currentRow.NMGRUPSERV.join('_');
			} else {
				grupoServicos = '';
			}
		} else {
			grupoServicos = 'T';
		} 
		General.onClickDependentField(widget.getField('NMSERVICO'), {CDFILIAL: currentRow.CDFILIAL, CDGRUPSERV: grupoServicos});
	};

	this.retornaCurvaABC = function(currentRow) {
		
		return restEngine.post('cus_relatorio#/cus01500_curva_abc_servico_planejado', {
			"requestType": "Row",
			"row": currentRow
		}, null, null, null, null, 60000);
	};

	this.excluiConsplanCus01500 = function() {
		
		return restEngine.post('cus_relatorio#/cus01500_exclui_consplan', {
			"requestType": "Row",
			"row": {}
		});
	};

	this.idProduto = function(widget) {
		var materiaPrima = widget.currentRow.IDMATEPRIM;
		var consumoFixo  = widget.currentRow.IDCONSFIXO;
		var consumoPer   = widget.currentRow.IDCONSPERC;
		var idProdutos 	 = '';

		if (materiaPrima == 'S') {
			idProdutos += 'C';
		} else {
			idProdutos += 'X';
		}

		if (consumoFixo == 'S') {
			idProdutos += 'F';
		} else {
			idProdutos += 'X';
		}

		if(consumoPer == 'S') {
			idProdutos += 'P';
		} else {
			idProdutos += 'X';
		}

		widget.currentRow.IDPRODUTOS = idProdutos;
	};

	this.validaNivel = function(currentRow, field) {
        var mensagem = "O produto final não pode ser maior que o inicial.";
        var retorno = '';
        
        if(currentRow.CDPRODINICIO && currentRow.CDPRODFINAL) {
            retorno = General.comparaPratoProduto(currentRow.CDPRODINICIO, currentRow.CDPRODFINAL, getLocalVar('CDPICTPROD'));
            if (!retorno) {
                ScreenService.showMessage(mensagem);
                return false;
            }
            return true;
        }
        return false;
    };

	this.validaCampos = function(currentRow, widget) {
		currentRow.DTINICIAL = currentRow.PERIODO.start;
		currentRow.DTFINAL = currentRow.PERIODO.end;
		currentRow.DTMESFINA = currentRow.PERIODO.end;
		currentRow.DTMESINIC = currentRow.PERIODO.start;
		currentRow.MASK ='!' + getLocalVar('CDPICTPROD').replace(/[^(/\.|\ )]/g, "@");
		currentRow.__report_name = currentRow.CD_REPORT_NAME;
		if(widget.isValid() && self.validaData(currentRow) && self.validaNivel(currentRow)) {
			widget.backupRow = angular.copy(widget.currentRow);
			prepareFilterReport(currentRow, widget);
			if (currentRow.ALLGRUPSERV == 'N' && currentRow.ALLCDSERVFILI == 'N') {

				currentRow.LISTAGRUPSERV = currentRow.NMGRUPSERV.join('_');
				currentRow.LISTASERV = currentRow.NMSERVICO.join('_');

			} else if (currentRow.ALLGRUPSERV == 'S' && currentRow.ALLCDSERVFILI == 'N') {

				currentRow.LISTAGRUPSERV = 'T';
				currentRow.LISTASERV = currentRow.NMSERVICO.join('_');

			} else if (currentRow.ALLGRUPSERV == 'N' && currentRow.ALLCDSERVFILI == 'S') {

				currentRow.LISTAGRUPSERV = currentRow.NMGRUPSERV.join('_');
				currentRow.LISTASERV = 'REQUEST';

			} else if (currentRow.ALLGRUPSERV == 'S' && currentRow.ALLCDSERVFILI == 'S') {

				currentRow.LISTAGRUPSERV = 'T';
				currentRow.LISTASERV = 'T';
			}

			self.idProduto(widget);
			self.salvaFilial(widget);
			if(currentRow.IDMATEPRIM == 'N' && currentRow.IDNESTOCAVEIS == 'N' && currentRow.IDCONSPERC == 'N' && currentRow.IDCONSFIXO == 'N'){
				ScreenService.showMessage("Pelo menos um tipo de produto deve ser informado");
				return;
			}
			/* 
			this.retornaCurvaABC(currentRow).then(function(callback) {
				dataSetTree = callback.dataset.cus01500_abcservicoplan;
				if(!dataSetTree.length) {
					ScreenService.showMessage("Não há dados a serem listados.");
				} else {
					ScreenService.openWindow('cus_relatorio#cus01500_grid_relatorio');
				}
			}, function() {
				ScreenService.showMessage('Operação não realizada. <br>Verifique sua conexão e tente novamente.');
			}); 
			*/
			General.openReport('cus_relatorio#/cus01500_curva_abc_servico_planejado_report', currentRow.__report_name, widget.currentRow);
		}
	};

	this.openReport = function(widget) {

		let reportFormats = [
			{
				name: "pdf",
				value: "PDF"
			},
			{
				name: "xlsx",
				value: "XLSX"
			}
		];

		General.openReportPopup(widget, this.validaCampos, [widget.currentRow, widget], reportFormats);

	};

	this.setaStripe = function(stripeWidget, parent, currentRow) {

		stripeWidget.getField('unidade').setValue(unidade);
		stripeWidget.getField('custoTotal').setValue('');
		if (parent.length) {
	        parent[0].CUSTOTOTPROD = applyMask(parent[0].CUSTOTOTPROD, 2);
			parent[0].CUSTOTOTPROD = typeof parent[0].CUSTOTOTPROD === 'string' ? parent[0].CUSTOTOTPROD.split('.').join(',') : parent[0].CUSTOTOTPROD;
			stripeWidget.getField('custoTotal').setValue(parent[0].CUSTOTOTPROD);
		}
	};

	var applyMask = function(fieldValue, maxlength) {

        var mask = {
            "type": "zerofill",
            "params": {
                "right": true,
                "maxlength": maxlength
            }
        };
        return Util.applyMask(fieldValue, mask, maskEngine, ZhUtil);
    };

	this.setaDataSet = function(gridWidget, stripeWidget) {

		gridWidget.activate();
		parent = dataSetTree.splice(0, 1);
		gridWidget.beforeGenerateReport = beforeGenerateReport;
		this.setaStripe(stripeWidget, parent);
		gridWidget.dataSource.data = dataSetTree;
	};

	this.salvaFilial = function(widget) {
		codigo  = widget.currentRow.CDFILIAL;
		unidade = widget.currentRow.NMFILIAL;
	};
};

Configuration(function(ContextRegister) {
	ContextRegister.register('Cus01500_CurvaABCServicoPlanejadoController', Cus01500_CurvaABCServicoPlanejadoController);
});